package net.horizoncode.tickettest;

import lombok.Getter;
import net.horizoncode.tickettest.manager.Ticket;
import net.horizoncode.tickettest.manager.TicketCallback;
import net.horizoncode.tickettest.manager.TicketManager;

import java.util.stream.IntStream;

public class TicketTest {

  @Getter private final TicketManager ticketManager;

  public static void main(String[] args) {
    new TicketTest();
  }

  public TicketTest() {
    this.ticketManager = TicketManager.builder().ticketLifespan(5000).maxTicketsExisting(2).build();

    IntStream.range(0, 10)
        .forEach(
            (value) ->
                getTicketManager()
                    .addTicket(
                        () -> {
                          System.out.println("i expired oof");
                        })
                    .use());

    while (true) {}
  }
}
